<template>
  <NuxtLink
    v-slot="{ navigate }"
    custom
    :to="historyPath"
  >
    <tr
      class="clickable-row"
      @click="navigate"
    >
      <td>
        <form
          v-if="canEditHistory"
          @click.stop
          @change="onUpdateRow('status', $event)"
        >
          <AtomSelect
            name="status"
            label="Statut"
            :options="statusOptions"
            :model-value="history.status"
            required
            no-label
            labelled-by="status-col"
            :disabled-options="pastStatuses"
          />
        </form>
        <span
          v-else
          class="fr-badge"
          :class="[statusClass]"
        >
          {{ statusOptions.get(history.status) }}
        </span>
      </td>
      <td v-if="isInterview">{{ INTERVIEW_TYPE_OPTIONS.get(history.type) }}</td>
      <td>{{ followUpTypes }}</td>
      <td v-if="isInterview || canAccessRestrictedFieldsInHelpRequest">
        <template v-if="canDisplayDetailedHistory">
          {{ formatDate(history.due_date) }}
        </template>
      </td>
      <td>
        {{ beneficiaryName(history.beneficiary) }}
      </td>
      <template v-if="!isInterview && canAccessRestrictedFieldsInHelpRequest">
        <td>
          <template v-if="canDisplayDetailedHistory">
            {{ examiningOrganisation }}
          </template>
        </td>
        <td>
          <template v-if="canDisplayDetailedHistory">
            {{ formatDate(history.examination_date) }}
          </template>
        </td>
        <td>
          <template v-if="canDisplayDetailedHistory && history.asked_amount">{{
            euros(history.asked_amount)
          }}</template>
        </td>
        <td>
          <template v-if="canDisplayDetailedHistory">
            <form
              v-if="canEditAllocatedAmount"
              @click.stop
              @change="onUpdateRow('allocated_amount', $event)"
            >
              <AtomCurrencyInput
                name="allocated_amount"
                label="Montant attribué"
                :value="history.allocated_amount"
                no-label
                labelled-by="allocated-amount-col"
              />
            </form>
            <template v-else-if="history.allocated_amount">
              {{ euros(history.allocated_amount) }}
            </template>
          </template>
        </td>
        <td>
          <template v-if="canDisplayDetailedHistory">
            <form
              v-if="canEditPaymentMethod"
              @click.stop
              @change="onUpdateRow('payment_method', $event)"
            >
              <AtomSelect
                name="payment_method"
                label="Mode de paiement"
                no-label
                labelled-by="payment-method-col"
                :options="withEmptyValue(PAYMENT_METHOD_OPTIONS)"
                :model-value="history.payment_method"
              />
            </form>
            <template v-else>
              {{ PAYMENT_METHOD_OPTIONS.get(history.payment_method) }}
            </template>
          </template>
        </td>
        <td>
          <template v-if="canDisplayDetailedHistory">
            <form
              v-if="canEditPaymentDate"
              @click.stop
              @change="onUpdateRow('payment_date', $event)"
            >
              <AtomInput
                name="payment_date"
                label="Date du paiement"
                type="date"
                no-label
                labelled-by="payment-date-col"
                :value="history.payment_date"
              />
            </form>
            <template v-else>
              {{ formatDate(history.payment_date) }}
            </template>
          </template>
        </td>
        <td>
          <template v-if="canDisplayDetailedHistory">{{
            formatDate(history.handling_date)
          }}</template>
        </td>
      </template>
      <td>{{ agentName(history.user_created) }}</td>
      <td>{{ readableFileNumber(history.beneficiary.id) }}</td>
    </tr>
  </NuxtLink>
</template>

<script setup>
  import {
    ORIGIN_PAGE_PARAMETER,
    ORIGIN_TAB_PARAMETER
  } from '~/utils/constants'
  import {
    INTERVIEWS_TAB_ID,
    HELP_REQUESTS_TAB_ID
  } from '~/utils/constants/history'
  import { BeneficiaryTab } from '~/utils/constants/beneficiary-tabs'
  import {
    HELP_REQUEST_STATUS_OPTIONS,
    STATUS_CLASSES as HELP_REQUEST_STATUS_CLASSES,
    PAYMENT_METHOD_OPTIONS,
    pastStatusesFromStatus,
    HelpRequestStatus
  } from '~/utils/constants/help-requests'
  import {
    INTERVIEW_STATUS_OPTIONS,
    STATUS_CLASSES as INTERVIEW_STATUS_CLASSES,
    INTERVIEW_TYPE_OPTIONS,
    INTERVIEWS_TABLE_FIELDS
  } from '~/utils/constants/interview'
  import {
    euros,
    readableFileNumber,
    agentName,
    formatDate,
    withEmptyValue
  } from '~/utils'
  import { usePermissionsStore } from '~/store/permissions'
  import { beneficiaryName } from '~/utils/beneficiary'
  import { Routes } from '~/utils/routing/routes'

  const { $apiRequest, $snackbar } = useNuxtApp()
  const permissionsStore = usePermissionsStore()
  const route = useRoute()

  const props = defineProps({
    history: { type: Object, required: true },
    isInterview: { type: Boolean, default: false }
  })

  const emit = defineEmits(['updated'])

  const historyPath = computed(() => {
    return {
      path: Routes.Beneficiary(props.history.beneficiary.id),
      query: {
        tab: BeneficiaryTab.History,
        item: props.history.id,
        [ORIGIN_PAGE_PARAMETER]: route.path,
        [ORIGIN_TAB_PARAMETER]: props.isInterview
          ? INTERVIEWS_TAB_ID
          : HELP_REQUESTS_TAB_ID
      }
    }
  })

  const historyCollection = computed(() =>
    props.isInterview ? 'follow_ups' : 'help_requests'
  )

  const examiningOrganisation = computed(() => {
    if (props.isInterview) return ''
    return props.history.external_organisation
      ? props.history.organisme_instructeur?.name || ''
      : 'Interne'
  })

  const statusOptions = computed(() =>
    props.isInterview ? INTERVIEW_STATUS_OPTIONS : HELP_REQUEST_STATUS_OPTIONS
  )

  const pastStatuses = computed(() => {
    if (props.isInterview) return []
    return pastStatusesFromStatus(props.history.status)
  })

  const statusClass = computed(() => {
    if (props.isInterview) {
      return INTERVIEW_STATUS_CLASSES[props.history.status] || ''
    }
    return HELP_REQUEST_STATUS_CLASSES[props.history.status] || ''
  })

  const followUpTypes = computed(() => {
    if (props.isInterview) {
      return props.history.follow_up_types
        .map(f => f.follow_up_types_id.name)
        .join(', ')
    }
    return props.history.follow_up_type.name
  })

  const canAccessRestrictedFieldsInHelpRequest = computed(
    () => permissionsStore.canAccessRestrictedFieldsInHelpRequest
  )

  const canDisplayDetailedHistory = computed(() =>
    permissionsStore.canDisplayDetailedHistory({
      ...props.history,
      isInterview: props.isInterview
    })
  )

  const canEditHistory = computed(() =>
    permissionsStore.canEditHistoryItem(props.history)
  )

  const isAcceptedHelpRequest = computed(
    () =>
      !props.isInterview && props.history.status === HelpRequestStatus.Accepted
  )

  const isFinancialSupport = computed(
    () => !props.isInterview && props.history.financial_support
  )

  const isExternalSupport = computed(
    () => !props.isInterview && props.history.external_organisation
  )

  const canEditAllocatedAmount = computed(
    () =>
      canEditHistory.value &&
      isAcceptedHelpRequest.value &&
      isFinancialSupport.value
  )

  const canEditPaymentMethod = computed(
    () =>
      canEditHistory.value &&
      isAcceptedHelpRequest.value &&
      !isExternalSupport.value
  )

  const canEditPaymentDate = computed(
    () =>
      canEditHistory.value &&
      isAcceptedHelpRequest.value &&
      !isExternalSupport.value
  )

  async function onUpdateRow(fieldName, { target }) {
    const { value, type } = target

    // A hack to prevent submitting dates while typing
    if (type === 'date' && value.startsWith('0')) return
    try {
      const fields = props.isInterview
        ? INTERVIEWS_TABLE_FIELDS
        : permissionsStore.accessibleHelpRequestFields

      const res = await $apiRequest(
        `/items/${historyCollection.value}/${props.history.id}`,
        {
          method: 'patch',
          data: {
            [fieldName]: value.length ? value : null
          }
        },
        fields ? { fields } : undefined
      )

      if (res.status === 200) {
        emit('updated', res.data.data)
        $snackbar.success(
          props.isInterview
            ? "L'entretien a été modifié"
            : "La demande d'aide a été modifiée"
        )
      } else throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error('La modification a échoué.')
    }
  }
</script>
